Retrieve an item
Get a single item from a conversation with the given IDs.
Query ParametersExpand Collapse
Additional fields to include in the response. See the include
parameter for listing Conversation items above for more information.
Additional fields to include in the response. See the include
parameter for listing Conversation items above for more information.
ReturnsExpand Collapse
ConversationItem = Message { id, content, role, 3 more } or object { id, arguments, call_id, 5 more } or object { id, call_id, output, 3 more } or 22 moreA single item within a conversation. The set of possible types are the same as the output type of a Response object.
A single item within a conversation. The set of possible types are the same as the output type of a Response object.
Message object { id, content, role, 3 more } A message to or from the model.
A message to or from the model.
content: array of ResponseInputText { text, type } or ResponseOutputText { annotations, logprobs, text, type } or TextContent { text, type } or 6 moreThe content of the message
The content of the message
ResponseOutputText object { annotations, logprobs, text, type } A text output from the model.
A text output from the model.
annotations: array of object { file_id, filename, index, type } or object { end_index, start_index, title, 2 more } or object { container_id, end_index, file_id, 3 more } or object { file_id, index, type } The annotations of the text output.
The annotations of the text output.
URLCitation object { end_index, start_index, title, 2 more } A citation for a web resource used to generate a model response.
A citation for a web resource used to generate a model response.
ResponseInputImage object { detail, type, file_id, image_url } An image input to the model. Learn about image inputs.
An image input to the model. Learn about image inputs.
ComputerScreenshotContent object { detail, file_id, image_url, type } A screenshot of a computer.
A screenshot of a computer.
role: "unknown" or "user" or "assistant" or 5 moreThe role of the message. One of unknown, user, assistant, system, critic, discriminator, developer, or tool.
The role of the message. One of unknown, user, assistant, system, critic, discriminator, developer, or tool.
status: "in_progress" or "completed" or "incomplete"The status of item. One of in_progress, completed, or incomplete. Populated when items are returned via API.
The status of item. One of in_progress, completed, or incomplete. Populated when items are returned via API.
phase: optional "commentary" or "final_answer"Labels an assistant message as intermediate commentary (commentary) or the final answer (final_answer). For models like gpt-5.3-codex and beyond, when sending follow-up requests, preserve and resend phase on all assistant messages — dropping it can degrade performance. Not used for user messages.
Labels an assistant message as intermediate commentary (commentary) or the final answer (final_answer). For models like gpt-5.3-codex and beyond, when sending follow-up requests, preserve and resend phase on all assistant messages — dropping it can degrade performance. Not used for user messages.
FunctionCall object { id, arguments, call_id, 5 more }
FunctionCallOutput object { id, call_id, output, 3 more }
output: string or array of ResponseInputText { text, type } or ResponseInputImage { detail, type, file_id, image_url } or ResponseInputFile { type, detail, file_data, 3 more } The output from the function call generated by your code.
Can be a string or an list of output content.
The output from the function call generated by your code. Can be a string or an list of output content.
OutputContentList = array of ResponseInputText { text, type } or ResponseInputImage { detail, type, file_id, image_url } or ResponseInputFile { type, detail, file_data, 3 more } Text, image, or file output of the function call.
Text, image, or file output of the function call.
ResponseInputImage object { detail, type, file_id, image_url } An image input to the model. Learn about image inputs.
An image input to the model. Learn about image inputs.
FileSearchCall object { id, queries, status, 2 more } The results of a file search tool call. See the
file search guide for more information.
The results of a file search tool call. See the file search guide for more information.
status: "in_progress" or "searching" or "completed" or 2 moreThe status of the file search tool call. One of in_progress,
searching, incomplete or failed,
The status of the file search tool call. One of in_progress,
searching, incomplete or failed,
results: optional array of object { attributes, file_id, filename, 2 more } The results of the file search tool call.
The results of the file search tool call.
attributes: optional map[string or number or boolean]Set of 16 key-value pairs that can be attached to an object. This can be
useful for storing additional information about the object in a structured
format, and querying for objects via API or the dashboard. Keys are strings
with a maximum length of 64 characters. Values are strings with a maximum
length of 512 characters, booleans, or numbers.
Set of 16 key-value pairs that can be attached to an object. This can be useful for storing additional information about the object in a structured format, and querying for objects via API or the dashboard. Keys are strings with a maximum length of 64 characters. Values are strings with a maximum length of 512 characters, booleans, or numbers.
WebSearchCall object { id, action, status, type } The results of a web search tool call. See the
web search guide for more information.
The results of a web search tool call. See the web search guide for more information.
action: object { query, type, queries, sources } or object { type, url } or object { pattern, type, url } An object describing the specific action taken in this web search call.
Includes details on how the model used the web (search, open_page, find_in_page).
An object describing the specific action taken in this web search call. Includes details on how the model used the web (search, open_page, find_in_page).
ImageGenerationCall object { id, result, status, type } An image generation request made by the model.
An image generation request made by the model.
ComputerCall object { id, call_id, pending_safety_checks, 4 more } A tool call to a computer use tool. See the
computer use guide for more information.
A tool call to a computer use tool. See the computer use guide for more information.
pending_safety_checks: array of object { id, code, message } The pending safety checks for the computer call.
The pending safety checks for the computer call.
status: "in_progress" or "completed" or "incomplete"The status of the item. One of in_progress, completed, or
incomplete. Populated when items are returned via API.
The status of the item. One of in_progress, completed, or
incomplete. Populated when items are returned via API.
A click action.
A click action.
Click object { button, type, x, 2 more } A click action.
A click action.
Drag object { path, type, keys } A drag action.
A drag action.
Flattened batched actions for computer_use. Each action includes an
type discriminator and action-specific fields.
Flattened batched actions for computer_use. Each action includes an
type discriminator and action-specific fields.
Click object { button, type, x, 2 more } A click action.
A click action.
Drag object { path, type, keys } A drag action.
A drag action.
ComputerCallOutput object { id, call_id, output, 4 more }
status: "completed" or "incomplete" or "failed" or "in_progress"The status of the message input. One of in_progress, completed, or
incomplete. Populated when input items are returned via API.
The status of the message input. One of in_progress, completed, or
incomplete. Populated when input items are returned via API.
ToolSearchCall object { id, arguments, call_id, 4 more }
ToolSearchOutput object { id, call_id, execution, 4 more }
status: "in_progress" or "completed" or "incomplete"The status of the tool search output item that was recorded.
The status of the tool search output item that was recorded.
tools: array of object { name, parameters, strict, 3 more } or object { type, vector_store_ids, filters, 2 more } or object { type } or 12 moreThe loaded tool definitions returned by tool search.
The loaded tool definitions returned by tool search.
Function object { name, parameters, strict, 3 more } Defines a function in your own code the model can choose to call. Learn more about function calling.
Defines a function in your own code the model can choose to call. Learn more about function calling.
FileSearch object { type, vector_store_ids, filters, 2 more } A tool that searches for relevant content from uploaded files. Learn more about the file search tool.
A tool that searches for relevant content from uploaded files. Learn more about the file search tool.
A filter to apply.
A filter to apply.
ComparisonFilter object { key, type, value } A filter used to compare a specified attribute key to a given value using a defined comparison operation.
A filter used to compare a specified attribute key to a given value using a defined comparison operation.
CompoundFilter object { filters, type } Combine multiple filters using and or or.
Combine multiple filters using and or or.
Array of filters to combine. Items can be ComparisonFilter or CompoundFilter.
Array of filters to combine. Items can be ComparisonFilter or CompoundFilter.
ComparisonFilter object { key, type, value } A filter used to compare a specified attribute key to a given value using a defined comparison operation.
A filter used to compare a specified attribute key to a given value using a defined comparison operation.
The maximum number of results to return. This number should be between 1 and 50 inclusive.
ranking_options: optional object { hybrid_search, ranker, score_threshold } Ranking options for search.
Ranking options for search.
Computer object { type } A tool that controls a virtual computer. Learn more about the computer tool.
A tool that controls a virtual computer. Learn more about the computer tool.
ComputerUsePreview object { display_height, display_width, environment, type } A tool that controls a virtual computer. Learn more about the computer tool.
A tool that controls a virtual computer. Learn more about the computer tool.
WebSearch object { type, filters, search_context_size, user_location } Search the Internet for sources related to the prompt. Learn more about the
web search tool.
Search the Internet for sources related to the prompt. Learn more about the web search tool.
type: "web_search" or "web_search_2025_08_26"The type of the web search tool. One of web_search or web_search_2025_08_26.
The type of the web search tool. One of web_search or web_search_2025_08_26.
search_context_size: optional "low" or "medium" or "high"High level guidance for the amount of context window space to use for the search. One of low, medium, or high. medium is the default.
High level guidance for the amount of context window space to use for the search. One of low, medium, or high. medium is the default.
user_location: optional object { city, country, region, 2 more } The approximate location of the user.
The approximate location of the user.
The two-letter ISO country code of the user, e.g. US.
The IANA timezone of the user, e.g. America/Los_Angeles.
Mcp object { server_label, type, allowed_tools, 7 more } Give the model access to additional tools via remote Model Context Protocol
(MCP) servers. Learn more about MCP.
Give the model access to additional tools via remote Model Context Protocol (MCP) servers. Learn more about MCP.
allowed_tools: optional array of string or object { read_only, tool_names } List of allowed tool names or a filter object.
List of allowed tool names or a filter object.
McpToolFilter object { read_only, tool_names } A filter object to specify which tools are allowed.
A filter object to specify which tools are allowed.
Indicates whether or not a tool modifies data or is read-only. If an
MCP server is annotated with readOnlyHint,
it will match this filter.
An OAuth access token that can be used with a remote MCP server, either with a custom MCP server URL or a service connector. Your application must handle the OAuth authorization flow and provide the token here.
connector_id: optional "connector_dropbox" or "connector_gmail" or "connector_googlecalendar" or 5 moreIdentifier for service connectors, like those available in ChatGPT. One of
server_url or connector_id must be provided. Learn more about service
connectors here.
Currently supported connector_id values are:
- Dropbox:
connector_dropbox
- Gmail:
connector_gmail
- Google Calendar:
connector_googlecalendar
- Google Drive:
connector_googledrive
- Microsoft Teams:
connector_microsoftteams
- Outlook Calendar:
connector_outlookcalendar
- Outlook Email:
connector_outlookemail
- SharePoint:
connector_sharepoint
Identifier for service connectors, like those available in ChatGPT. One of
server_url or connector_id must be provided. Learn more about service
connectors here.
Currently supported connector_id values are:
- Dropbox:
connector_dropbox - Gmail:
connector_gmail - Google Calendar:
connector_googlecalendar - Google Drive:
connector_googledrive - Microsoft Teams:
connector_microsoftteams - Outlook Calendar:
connector_outlookcalendar - Outlook Email:
connector_outlookemail - SharePoint:
connector_sharepoint
Optional HTTP headers to send to the MCP server. Use for authentication or other purposes.
require_approval: optional object { always, never } or "always" or "never"Specify which of the MCP server’s tools require approval.
Specify which of the MCP server’s tools require approval.
McpToolApprovalFilter object { always, never } Specify which of the MCP server’s tools require approval. Can be
always, never, or a filter object associated with tools
that require approval.
Specify which of the MCP server’s tools require approval. Can be
always, never, or a filter object associated with tools
that require approval.
always: optional object { read_only, tool_names } A filter object to specify which tools are allowed.
A filter object to specify which tools are allowed.
Indicates whether or not a tool modifies data or is read-only. If an
MCP server is annotated with readOnlyHint,
it will match this filter.
never: optional object { read_only, tool_names } A filter object to specify which tools are allowed.
A filter object to specify which tools are allowed.
Indicates whether or not a tool modifies data or is read-only. If an
MCP server is annotated with readOnlyHint,
it will match this filter.
CodeInterpreter object { container, type } A tool that runs Python code to help generate a response to a prompt.
A tool that runs Python code to help generate a response to a prompt.
container: string or object { type, file_ids, memory_limit, network_policy } The code interpreter container. Can be a container ID or an object that
specifies uploaded file IDs to make available to your code, along with an
optional memory_limit setting.
The code interpreter container. Can be a container ID or an object that
specifies uploaded file IDs to make available to your code, along with an
optional memory_limit setting.
CodeInterpreterToolAuto object { type, file_ids, memory_limit, network_policy } Configuration for a code interpreter container. Optionally specify the IDs of the files to run the code on.
Configuration for a code interpreter container. Optionally specify the IDs of the files to run the code on.
An optional list of uploaded files to make available to your code.
memory_limit: optional "1g" or "4g" or "16g" or "64g"The memory limit for the code interpreter container.
The memory limit for the code interpreter container.
network_policy: optional ContainerNetworkPolicyDisabled { type } or ContainerNetworkPolicyAllowlist { allowed_domains, type, domain_secrets } Network access policy for the container.
Network access policy for the container.
ImageGeneration object { type, action, background, 9 more } A tool that generates images using the GPT image models.
A tool that generates images using the GPT image models.
action: optional "generate" or "edit" or "auto"Whether to generate a new image or edit an existing image. Default: auto.
Whether to generate a new image or edit an existing image. Default: auto.
background: optional "transparent" or "opaque" or "auto"Background type for the generated image. One of transparent,
opaque, or auto. Default: auto.
Background type for the generated image. One of transparent,
opaque, or auto. Default: auto.
input_fidelity: optional "high" or "low"Control how much effort the model will exert to match the style and features, especially facial features, of input images. This parameter is only supported for gpt-image-1 and gpt-image-1.5 and later models, unsupported for gpt-image-1-mini. Supports high and low. Defaults to low.
Control how much effort the model will exert to match the style and features, especially facial features, of input images. This parameter is only supported for gpt-image-1 and gpt-image-1.5 and later models, unsupported for gpt-image-1-mini. Supports high and low. Defaults to low.
input_image_mask: optional object { file_id, image_url } Optional mask for inpainting. Contains image_url
(string, optional) and file_id (string, optional).
Optional mask for inpainting. Contains image_url
(string, optional) and file_id (string, optional).
model: optional string or "gpt-image-1" or "gpt-image-1-mini" or "gpt-image-1.5"The image generation model to use. Default: gpt-image-1.
The image generation model to use. Default: gpt-image-1.
Compression level for the output image. Default: 100.
output_format: optional "png" or "webp" or "jpeg"The output format of the generated image. One of png, webp, or
jpeg. Default: png.
The output format of the generated image. One of png, webp, or
jpeg. Default: png.
Number of partial images to generate in streaming mode, from 0 (default value) to 3.
LocalShell object { type } A tool that allows the model to execute shell commands in a local environment.
A tool that allows the model to execute shell commands in a local environment.
Shell object { type, environment } A tool that allows the model to execute shell commands.
A tool that allows the model to execute shell commands.
environment: optional ContainerAuto { type, file_ids, memory_limit, 2 more } or LocalEnvironment { type, skills } or ContainerReference { container_id, type }
ContainerAuto object { type, file_ids, memory_limit, 2 more }
An optional list of uploaded files to make available to your code.
network_policy: optional ContainerNetworkPolicyDisabled { type } or ContainerNetworkPolicyAllowlist { allowed_domains, type, domain_secrets } Network access policy for the container.
Network access policy for the container.
skills: optional array of SkillReference { skill_id, type, version } or InlineSkill { description, name, source, type } An optional list of skills referenced by id or inline data.
An optional list of skills referenced by id or inline data.
Custom object { name, type, defer_loading, 2 more } A custom tool that processes input using a specified format. Learn more about custom tools
A custom tool that processes input using a specified format. Learn more about custom tools
Namespace object { description, name, tools, type } Groups function/custom tools under a shared namespace.
Groups function/custom tools under a shared namespace.
tools: array of object { name, type, defer_loading, 3 more } or object { name, type, defer_loading, 2 more } The function/custom tools available inside this namespace.
The function/custom tools available inside this namespace.
Custom object { name, type, defer_loading, 2 more } A custom tool that processes input using a specified format. Learn more about custom tools
A custom tool that processes input using a specified format. Learn more about custom tools
ToolSearch object { type, description, execution, parameters } Hosted or BYOT tool search configuration for deferred tools.
Hosted or BYOT tool search configuration for deferred tools.
WebSearchPreview object { type, search_content_types, search_context_size, user_location } This tool searches the web for relevant results to use in a response. Learn more about the web search tool.
This tool searches the web for relevant results to use in a response. Learn more about the web search tool.
type: "web_search_preview" or "web_search_preview_2025_03_11"The type of the web search tool. One of web_search_preview or web_search_preview_2025_03_11.
The type of the web search tool. One of web_search_preview or web_search_preview_2025_03_11.
search_context_size: optional "low" or "medium" or "high"High level guidance for the amount of context window space to use for the search. One of low, medium, or high. medium is the default.
High level guidance for the amount of context window space to use for the search. One of low, medium, or high. medium is the default.
user_location: optional object { type, city, country, 2 more } The user’s location.
The user’s location.
The two-letter ISO country code of the user, e.g. US.
The IANA timezone of the user, e.g. America/Los_Angeles.
Reasoning object { id, summary, type, 3 more } A description of the chain of thought used by a reasoning model while generating
a response. Be sure to include these items in your input to the Responses API
for subsequent turns of a conversation if you are manually
managing context.
A description of the chain of thought used by a reasoning model while generating
a response. Be sure to include these items in your input to the Responses API
for subsequent turns of a conversation if you are manually
managing context.
Compaction object { id, encrypted_content, type, created_by } A compaction item generated by the v1/responses/compact API.
A compaction item generated by the v1/responses/compact API.
CodeInterpreterCall object { id, code, container_id, 3 more } A tool call to run code.
A tool call to run code.
outputs: array of object { logs, type } or object { type, url } The outputs generated by the code interpreter, such as logs or images.
Can be null if no outputs are available.
The outputs generated by the code interpreter, such as logs or images. Can be null if no outputs are available.
LocalShellCall object { id, action, call_id, 2 more } A tool call to run a command on the local shell.
A tool call to run a command on the local shell.
LocalShellCallOutput object { id, output, type, status } The output of a local shell tool call.
The output of a local shell tool call.
ShellCall object { id, action, call_id, 4 more } A tool call that executes one or more shell commands in a managed environment.
A tool call that executes one or more shell commands in a managed environment.
action: object { commands, max_output_length, timeout_ms } The shell commands and limits that describe how to run the tool call.
The shell commands and limits that describe how to run the tool call.
Represents the use of a local environment to perform shell actions.
Represents the use of a local environment to perform shell actions.
ShellCallOutput object { id, call_id, max_output_length, 4 more } The output of a shell tool call that was emitted.
The output of a shell tool call that was emitted.
The maximum length of the shell command output. This is generated by the model and should be passed back with the raw output.
output: array of object { outcome, stderr, stdout, created_by } An array of shell call output contents
An array of shell call output contents
ApplyPatchCall object { id, call_id, operation, 3 more } A tool call that applies file diffs by creating, deleting, or updating files.
A tool call that applies file diffs by creating, deleting, or updating files.
operation: object { diff, path, type } or object { path, type } or object { diff, path, type } One of the create_file, delete_file, or update_file operations applied via apply_patch.
One of the create_file, delete_file, or update_file operations applied via apply_patch.
ApplyPatchCallOutput object { id, call_id, status, 3 more } The output emitted by an apply patch tool call.
The output emitted by an apply patch tool call.
McpListTools object { id, server_label, tools, 2 more } A list of tools available on an MCP server.
A list of tools available on an MCP server.
McpApprovalRequest object { id, arguments, name, 2 more } A request for human approval of a tool invocation.
A request for human approval of a tool invocation.
McpApprovalResponse object { id, approval_request_id, approve, 2 more } A response to an MCP approval request.
A response to an MCP approval request.
McpCall object { id, arguments, name, 6 more } An invocation of a tool on an MCP server.
An invocation of a tool on an MCP server.
CustomToolCall object { call_id, input, name, 3 more } A call to a custom tool created by the model.
A call to a custom tool created by the model.
CustomToolCallOutput object { call_id, output, type, id } The output of a custom tool call from your code, being sent back to the model.
The output of a custom tool call from your code, being sent back to the model.
output: string or array of ResponseInputText { text, type } or ResponseInputImage { detail, type, file_id, image_url } or ResponseInputFile { type, detail, file_data, 3 more } The output from the custom tool call generated by your code.
Can be a string or an list of output content.
The output from the custom tool call generated by your code. Can be a string or an list of output content.
OutputContentList = array of ResponseInputText { text, type } or ResponseInputImage { detail, type, file_id, image_url } or ResponseInputFile { type, detail, file_data, 3 more } Text, image, or file output of the custom tool call.
Text, image, or file output of the custom tool call.
ResponseInputImage object { detail, type, file_id, image_url } An image input to the model. Learn about image inputs.
An image input to the model. Learn about image inputs.
Retrieve an item
curl https://api.openai.com/v1/conversations/conv_123/items/msg_abc \
-H "Authorization: Bearer $OPENAI_API_KEY"
{
"type": "message",
"id": "msg_abc",
"status": "completed",
"role": "user",
"content": [
{"type": "input_text", "text": "Hello!"}
]
}
Returns Examples
{
"type": "message",
"id": "msg_abc",
"status": "completed",
"role": "user",
"content": [
{"type": "input_text", "text": "Hello!"}
]
}